import java.lang.Math;
import java.util.Random;
import java.awt.Color;
import jrobots.utils.*;

import jrobots.simulation.simulationObjects.JRobot2010;

/**
 * Hallo du da!
 */
public class OurBot extends JRobot2010 {

    /**
	 * 
	 */
	private static final long serialVersionUID = -7787615938440661822L;
	private Angle scanAperture; //momentary scanAperture, needed in next frame 
    private Angle scanDirection; //momentary scanDirection, needed in next frame 
    private Scan latestSuccessfulScan; //last scanned target
    private Scan latestScan;
    private Scan ersterScan;
    private int scanState;
    private int durchgang = 75;
    private int winkel = 90;
    private boolean gefunden = false;
    private int dreh = 10;
    private int modus;
    private int old = 0;
    private int firemode = 0;
    private int nichtgefunden = 0;
    private int p_M = 0;
    
    
    private Color zufallsfarbe()
    {
    	Random r = new Random();
    	int i = r.nextInt(13);
    	
    	switch (i)
    	{
    	case 0:
    		return Color.BLACK;
    	case 1:
    		return Color.BLUE;
    	case 2:
    		return Color.cyan;
    	case 3:
    		return Color.DARK_GRAY;
    	case 4:
    		return Color.gray;
    	case 5:
    		return Color.green;
    	case 6:
    		return Color.LIGHT_GRAY;
    	case 7:
    		return Color.magenta;
    	case 8:
    		return Color.orange;
    	case 9:
    		return Color.pink;
    	case 10:
    		return Color.red;
    	case 11:
    		return Color.white;
    	case 12:
    		return Color.yellow;
		default:
			return Color.black;
    	}
	}
    /**
     * Sensoren auswerten
     */
    private void collect() {
        // Scanner nur auswerten, wenn gerade gescannt wurde
        if (isScanFromNow()) {
            if (this.getLastScan().isTargetLocated()) 
            {
                latestSuccessfulScan = this.getLastScan();
                gefunden = true;
            }           
            else
            	gefunden = false;
        }
    }
    
    
    /**
     * Wohin soll der Scanner ausgerichtet werden?
     */
    private void scan() {
        // Scanner neu ausrichten, wenn gerade gescannt wurde
        if (isScanFromNow()) 
        {
        	if (this.getHealth() < 0.25)
        	{
        		winkel = 5;
        	}
        	else if (gefunden)
            {
            	nichtgefunden = 0;
            	if (winkel == 90)
            	{
            		winkel = 45;
            	}
            	else if (winkel == 45)
            	{
            		winkel = 30;
            	}
            	else if (winkel == 30)
            	{
            		winkel = 20;
            	}
            	/*else if (winkel == 20)
            	{
            		winkel = 10;
            	}
            	else if (winkel == 10)
            	{
            		winkel = 5;
//            	}*/
            }
            else
            {
            	if (winkel == 5)
            	{
            		winkel = 20;
            	}
            	nichtgefunden++;
            	if (nichtgefunden > 3)
            	{
            		nichtgefunden = 0;
            		if (winkel == 5)
                	{
                		winkel = 20;
                	}
                	else if (winkel == 10)
                	{
                		winkel = 20;
                	}
                	else if (winkel == 20)
                	{
                		winkel = 45;
                	}
                	else if (winkel == 30)
                	{
                		winkel = 45;
                	}
                	else if (winkel == 45)
                	{
                		winkel = 90;
                	}
            	}
            }
            // 360 Grad scannen
            
            // naechster Scannerzustand
            scanState++; 
            // wegen modulo gibt's keinen Ueberlauf
            scanState = scanState % Math.max(3, (int)Math.ceil(360.0 / new Angle(winkel,"d").getValueAsDegrees()));
            // maximaler Oeffnungswinkel
   /*         if (durchgang == 1)
            {
            	if (latestSuccessfulScan != null) 
                {
                    winkel = 20;
            		scanAperture = new Angle(20, "d");
            		durchgang = 3;
                }
                else
                {
                	scanDirection.add(new Angle(-40,"d"));
                	
                }
            	durchgang++;
            }
            else if (durchgang == 2)
            {
            	if (latestSuccessfulScan == null)
            	{
            		durchgang = 0;
            	}
            	else
            	{
            		winkel = 20;
            		scanAperture = new Angle(20, "d");
            		durchgang = 3;
            	}
            }
            else if (durchgang == 3)
            {
            	if (latestSuccessfulScan != null) 
                {
            		winkel = 10;
            		scanAperture = new Angle(10, "d");
            		durchgang = 5;
                }
                else
                {
                	scanDirection.add(new Angle(-20,"d"));
                	durchgang++;
                }
            	
            }
            else if (durchgang == 4)
            {
            	if (latestSuccessfulScan == null)
            	{
            		durchgang = 0;
            	}
            	else
            	{
            		winkel = 10;
            		scanAperture = new Angle(10, "d");
            		durchgang = 5;
            	}
            }
            else if (durchgang == 5)
            {
            	if (latestSuccessfulScan != null) 
                {
                }
                else
                {
                	scanDirection.add(new Angle(-10,"d"));
                	
                }
            	durchgang++;
            }
            else if (durchgang == 6)
            {
            	if (latestSuccessfulScan == null)
            	{
            		durchgang = 0;
            	}
            }            
            else if (latestSuccessfulScan == null)
            {
            	durchgang = 0;
            	winkel = 80;
            	scanAperture = new Angle(80, "d");
            	scanDirection = (new Angle(360, "Degrees")).mult((double)scanState / scan_ROUNDABOUT_COUNT);
            }
            else
            {
            	if (durchgang == 0)
            	{
            		winkel = 40;
            		scanAperture = new Angle(40, "d");
            		durchgang++;
            	}
            		
            }
            
            // Oeffnungswinkel und Scanrichtung an Scanner durchgeben
            setScanAperture(scanAperture);
            setScanDirection(scanDirection);
            
			*/

            
            
            if (!gefunden && modus == 0)
            {
            	scanAperture = new Angle(winkel, "d");
            	scanDirection = scanDirection.add(new Angle(dreh,"d"));
            	setScanAperture(scanAperture);
            	setScanDirection(scanDirection);
            }  
            else if (gefunden && modus == 0)
            {       
            	if (this.getHealth() <= 0.25)
            	{
            		if (dreh == 10 || dreh == 5 || dreh == 4)
            			dreh = -4;
            		else
            			dreh = 4;
            	}
            	else if (winkel > 10)
            	{
            		if (dreh == 10 || dreh == 5 || dreh == 4)
            			dreh = -10;
            		else
            			dreh = 10;
            	}
            	else if (winkel <= 10)
            	{
            		if (dreh == 10 || dreh == 5 || dreh == 4)
            			dreh = -5;
            		else
            			dreh = 5;
            	}
            	modus = 1;
            	scanAperture = new Angle(winkel, "d");
            	scanDirection = scanDirection.add(new Angle(dreh,"d"));
            	setScanAperture(scanAperture);
            	setScanDirection(scanDirection);
            }
            else if (!gefunden && modus == 1)
            {
            	if (this.getHealth() <= 0.25)
            	{
            		if (dreh == 10 || dreh == 5 || dreh == 4)
            			dreh = -4;
            		else
            			dreh = 4;
            	}
            	else if (winkel > 10)
            	{
            		if (dreh == 10 || dreh == 5 || dreh == 4)
            			dreh = -10;
            		else
            			dreh = 10;
            	}
            	else if (winkel <= 10)
            	{
            		if (dreh == 10 || dreh == 5 || dreh == 4)
            			dreh = -5;
            		else
            			dreh = 5;
            	}
            	
            	scanAperture = new Angle(winkel, "d");
            	scanDirection = scanDirection.add(new Angle(dreh,"d"));
            	setScanAperture(scanAperture);
            	setScanDirection(scanDirection);
            	modus = 0;
            }
            else
            {
            	scanAperture = new Angle(winkel, "d");
            	scanDirection = scanDirection.add(new Angle(dreh,"d"));
            	setScanAperture(scanAperture);
            	setScanDirection(scanDirection);
            }
        } 
        else 
        {
            // Wenn noch nicht gescannt wurde, zur Sicherheit nochmal Befehl setzen
            setScanAperture(scanAperture);
            setScanDirection(scanDirection);
        }
        
    }
    

	/**
     * Wohin soll geschossen werden?
     */
    private void shoot() 
    {
    	Vector genauePosition = null;
    	Angle myAngle = null;
    	if (latestSuccessfulScan != null)
		{
			if (ersterScan != null )
			{
		    	Vector ersterVektor = ersterScan.estimatedTargetPosition();
				Vector zweiterVektor = latestScan.estimatedTargetPosition();
				Vector diff = ((zweiterVektor.sub(ersterVektor)).mult(0.5f));
				genauePosition = ersterVektor.add(diff); 
				double winkelbogenmas = -(Math.atan((this.getPosition().getY() - genauePosition.getY()) / (-(this.getPosition().getX() - genauePosition.getX())))) -0.34906585;
				if (this.getPosition().getX() - genauePosition.getX() > 0)
					winkelbogenmas = (Math.atan((this.getPosition().getY() - genauePosition.getY()) / (-(this.getPosition().getX() - genauePosition.getX())))) -0.34906585;
				System.out.print(this.getTime() + ": " + winkelbogenmas + "\n");
		    	myAngle = new Angle(winkelbogenmas, "Radians");
		    	System.out.print(this.getTime() + ": " + myAngle.getValueAsDegrees() + "\n");
		    	addDebugArrow(this.getPosition(), genauePosition);
			}
			ersterScan = latestScan;
		}
    	

    	
    	if (latestSuccessfulScan != null)
    	{
    		latestScan = latestSuccessfulScan;
    	}
    	
    	
    	if ( durchgang == 25 )
    	{
    		firemode = 2;
    	}
    	else if ( durchgang == 50)
    	{ 
    			firemode = 3;
    		
    		//mine = !mine;
    	}
    	else if (durchgang == 75  )
    	{
    		firemode = 4;
    		durchgang = 0;
    	}
    	else if ( durchgang == 51 || durchgang == 52 || durchgang == 53 || durchgang == 54 )
    	{
    		firemode = 5;
    	}
    	else
    	{
    		firemode = 1;
    		durchgang++;
    	}
    	
    	switch (firemode)
    	{
    	case 1:
    			if (getHealth() > 0.25)
    				setLaunchProjectileCommand(latestScan.scanDirection.add(new Angle(winkel/2 + 9 ,"d")));
    			else
    			{
    				if (p_M == 0)
    					setDropMineCommand(true);
    				else
    					setDropTankTrapCommand(true);
    				p_M = p_M++;
    				if (p_M == 2)
    					p_M = 0;
    			}
    			/*if (genauePosition != null)
    				setLaunchProjectileCommand(myAngle);
    			else
    				setLaunchProjectileCommand(latestScan.scanDirection.add(new Angle(winkel/2 - 5 ,"d"))); */
        		durchgang++;
        	break;
    	case 2:
        		setDropMineCommand(true);
        		durchgang++;
        	break;
    	case 3:
        		setLaunchMissileCommand(latestScan.scanDirection.add(new Angle(winkel/2 - 5,"d")));
        		durchgang++;
        	break;
    	case 4:
    			setDropTankTrapCommand(true);
    			durchgang++;
			break;
    	case 5:		
    			durchgang++;
    	}
    	if (genauePosition != null)
		{

    		addDebugCrosshair(genauePosition); //.rotate( new Angle(10,"d"))
    		setMissileTarget(genauePosition);

		}
    	
    	if (this.getHealth() < 0.25)
    	{
    		//this.setDropTankTrapCommand(true);
    	}
    	
    	setNameColor(zufallsfarbe());
    	setTurretColor(zufallsfarbe());
    	setBodyColor(zufallsfarbe());
    	setDebugText("Und Schuss... :P");
    	 	
    }
   
    /**
     * Wohin f&auml;hrt der JRobot?
     */
    private void drive() 
    {
    	int j = -25;
    	old++;
    	if (old == 1)
    		j = -20;
    	else if (old == 2)
    		j = -25;
    	else if (old == 3)
    		j = -30;
    	else
    	{
    		j = -25;
    		old = 0;
    	}

        // in Richtung des letzten gescannten Gegners fahren   
    	if(this.getHealth() > 0.25)
    	{
    		if (latestSuccessfulScan != null)
    			setAutopilot(latestSuccessfulScan.scanDirection.add(new Angle(j, "d")), 1.0f);
    	}
    	else
    	{
    		setAutopilot(latestSuccessfulScan.scanDirection.add(new Angle(205 + j, "d")), 1.0f);
    	}
    }
    
    
    @Override
    protected void actions() {
    			calibrate(); //should be first
        
    			collect(); //must be before scan
        
    			scan(); //must be before drive
    	
    			shoot();
        
    			drive();
    }
    
    @Override
    protected void init() {
        setNameColor(new Color((float)0.0,(float)0.0,(float)0.0));
        setAutopilot(getOrientation(), 1.0);
        scanAperture = new Angle(90, "d");
        scanDirection = getOrientation();
        setScanAperture(scanAperture);
        setScanDirection(scanDirection);
        latestSuccessfulScan = new Scan(
                RIGHT, 
                new Angle(360, "d"),
                Double.MAX_VALUE,
                this.getPosition(),
                Double.NEGATIVE_INFINITY);
    }
    
    /**
     * Hier berechnet der Bot aus den "Konstanten" der Umwelt abgeleitete Werte, 
     * die er in seinen Routinen <code>scan()</code>, <code>shoot()</code> und
     * <code>drive()</code> verwendet.  
     */
    private void calibrate() {
    }

}
